 // MainDlg.cpp : implementation file
//

#include "stdlib.h"
#include "stdafx.h"
#include "WCalc.h"
#include "MainDlg.h"

//---------------------------------------------------------------------------------
#include "MyWCalcLib.h"
using namespace MyWCalcLib;
//---------------------------------------------------------------------------------

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//---------------------------------------------------------------------------------
const int MaxArguments = 3;
MyDArg agArg[MaxArguments];

MyOperation CurrentOper = (MyOperation)0;
MyFunctionEqual CurrentFuncEqual = (MyFunctionEqual)0;
MyFunctionPercent CurrentFuncPercent = (MyFunctionPercent)0;
MyFunction CurrentFunc = (MyFunction)0;

MyCStrArg& Buffer = *(new MyCStrArg);

bool bDisabledBtns = false;
//---------------------------------------------------------------------------------

// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMainDlg dialog



CMainDlg::CMainDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMainDlg::IDD, pParent)
{
//---------------------------------------------------------------------------------
	m_hIcon = AfxGetApp()->LoadIcon(IDI_MYICON);
//---------------------------------------------------------------------------------
}

void CMainDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMainDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_CONTROL_RANGE(BN_CLICKED, IDC_BTN_C, IDC_BTN_M_PLUS, OnBnClickedButton)
END_MESSAGE_MAP()


// CMainDlg message handlers

BOOL CMainDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

//---------------------------------------------------------------------------------
	SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
//---------------------------------------------------------------------------------

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMainDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMainDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMainDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMainDlg::OnBnClickedButton(UINT nID)
{
//---------------------------------------------------------------------------------
	try
	{
		if(bDisabledBtns && nID != IDC_BTN_CE && nID != IDC_BTN_C)
			throw MyError(DISABLEDBUTTONS);
		switch(nID)
		{
//---------------------------------------------------------------------------------
//----------------------------- --------------------------------------
//---------------------------------------------------------------------------------
		case IDC_BTN_PLUS_MINUS:
			if(MyCStrArg::GetcMyCStrArg() == NOTEXIST)
				Buffer = *(new MyCStrArg);
			Buffer.ChangeSign();

			SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
			break;

		case IDC_BTN_POINT:
			if(MyCStrArg::GetcMyCStrArg() == NOTEXIST)
				Buffer = *(new MyCStrArg);
			Buffer += ',';

			SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
			break;

		case IDC_BTN_NULL:
			if(MyCStrArg::GetcMyCStrArg() == NOTEXIST)
				Buffer = *(new MyCStrArg);
			Buffer += '0';

			SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
			break;

		case IDC_BTN_1:
			if(MyCStrArg::GetcMyCStrArg() == NOTEXIST)
				Buffer = *(new MyCStrArg);
			Buffer += '1';

			SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
			break;

		case IDC_BTN_2:
			if(MyCStrArg::GetcMyCStrArg() == NOTEXIST)
				Buffer = *(new MyCStrArg);
			Buffer += '2';

			SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
			break;

		case IDC_BTN_3:
			if(MyCStrArg::GetcMyCStrArg() == NOTEXIST)
				Buffer = *(new MyCStrArg);
			Buffer += '3';

			SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
			break;

		case IDC_BTN_4:
			if(MyCStrArg::GetcMyCStrArg() == NOTEXIST)
				Buffer = *(new MyCStrArg);
			Buffer += '4';

			SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
			break;

		case IDC_BTN_5:
			if(MyCStrArg::GetcMyCStrArg() == NOTEXIST)
				Buffer = *(new MyCStrArg);
			Buffer += '5';

			SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
			break;

		case IDC_BTN_6:
			if(MyCStrArg::GetcMyCStrArg() == NOTEXIST)
				Buffer = *(new MyCStrArg);
			Buffer += '6';

			SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
			break;

		case IDC_BTN_7:
			if(MyCStrArg::GetcMyCStrArg() == NOTEXIST)
				Buffer = *(new MyCStrArg);
			Buffer += '7';

			SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
			break;

		case IDC_BTN_8:
			if(MyCStrArg::GetcMyCStrArg() == NOTEXIST)
				Buffer = *(new MyCStrArg);
			Buffer += '8';

			SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
			break;

		case IDC_BTN_9:
			if(MyCStrArg::GetcMyCStrArg() == NOTEXIST)
				Buffer = *(new MyCStrArg);
			Buffer += '9';

			SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
			break;

		case IDC_BTN_BACKSP:
			if(MyCStrArg::GetcMyCStrArg() == NOTEXIST)
				throw MyError(BACKSPACENOTEXISTINGARGUMENT);
			Buffer.Backspace();
			
			SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
			break;

//---------------------------------------------------------------------------------
//------------------------------ ---------------------------------------
//---------------------------------------------------------------------------------

		case IDC_BTN_CE:
			if(MyCStrArg::GetcMyCStrArg() == EXIST)
				delete (&Buffer);
			if(CurrentFuncEqual == (MyFunctionEqual)0)
				Buffer = *(new MyCStrArg);

			bDisabledBtns = false;

			if(CurrentFuncEqual == (MyFunctionEqual)0)
				SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
			else
				SetDlgItemText(IDC_EDT_STR, _T("0,"));
			break;

//---------------------------------------------------------------------------------
//---------------    ,  ------------------
//---------------------------------------------------------------------------------

		case IDC_BTN_C:
			agArg[FIRSTARG] = MyDArg();
			agArg[SECONDARG] = MyDArg();

			CurrentOper = (MyOperation)0;
			CurrentFuncEqual = (MyFunctionEqual)0;
			CurrentFuncPercent = (MyFunctionPercent)0;
			CurrentFunc = (MyFunction)0;

			if(MyCStrArg::GetcMyCStrArg() == EXIST)
				delete (&Buffer);
			Buffer = *(new MyCStrArg);

			bDisabledBtns = false;

			SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
			break;

//---------------------------------------------------------------------------------
//-------------------------------------------------------------------------
//---------------------------------------------------------------------------------

		case IDC_BTN_PLUS:
			if(CurrentFuncEqual == (MyFunctionEqual)0)
			{
				if(CurrentOper == (MyOperation)0)
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[FIRSTARG] = Buffer;
						delete (&Buffer);
					}

					CurrentOper = PLUS;
				}
				else
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[SECONDARG] = Buffer;
						delete (&Buffer);
					}

					if(agArg[SECONDARG].GetCondition() == NOTEMPTY)
					{
						CalculateEqual(agArg[FIRSTARG], agArg[SECONDARG], CurrentOper);

						agArg[SECONDARG] = MyDArg();

						SetDlgItemText(IDC_EDT_STR, (CString)agArg[FIRSTARG]);
					}

					CurrentOper = PLUS;
				}
			}
			else
			{
				if(CurrentFuncPercent == CALCULATEPERCENT || CurrentFunc != (MyFunction)0)
				{
					agArg[FIRSTARG] = agArg[SECONDARG];
				}
				agArg[SECONDARG] = MyDArg();

				CurrentOper = PLUS;
				CurrentFuncEqual = (MyFunctionEqual)0;
				CurrentFuncPercent = (MyFunctionPercent)0;
				CurrentFunc = (MyFunction)0;
			}
			break;

		case IDC_BTN_MINUS:
			if(CurrentFuncEqual == (MyFunctionEqual)0)
			{
				if(CurrentOper == (MyOperation)0)
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[FIRSTARG] = Buffer;
						delete (&Buffer);
					}

					CurrentOper = MINUS;
				}
				else
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[SECONDARG] = Buffer;
						delete (&Buffer);
					}

					if(agArg[SECONDARG].GetCondition() == NOTEMPTY)
					{
						CalculateEqual(agArg[FIRSTARG], agArg[SECONDARG], CurrentOper);

						agArg[SECONDARG] = MyDArg();

						SetDlgItemText(IDC_EDT_STR, (CString)agArg[FIRSTARG]);
					}

					CurrentOper = MINUS;
				}
			}
			else
			{
				if(CurrentFuncPercent == CALCULATEPERCENT || CurrentFunc != (MyFunction)0)
				{
					agArg[FIRSTARG] = agArg[SECONDARG];
				}
				agArg[SECONDARG] = MyDArg();

				CurrentOper = MINUS;
				CurrentFuncEqual = (MyFunctionEqual)0;
				CurrentFuncPercent = (MyFunctionPercent)0;
				CurrentFunc = (MyFunction)0;
			}
			break;

		case IDC_BTN_MULTIPLEYING:
			if(CurrentFuncEqual == (MyFunctionEqual)0)
			{
				if(CurrentOper == (MyOperation)0)
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[FIRSTARG] = Buffer;
						delete (&Buffer);
					}

					CurrentOper = MULTIPLEYING;
				}
				else
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[SECONDARG] = Buffer;
						delete (&Buffer);
					}

					if(agArg[SECONDARG].GetCondition() == NOTEMPTY)
					{
						CalculateEqual(agArg[FIRSTARG], agArg[SECONDARG], CurrentOper);

						agArg[SECONDARG] = MyDArg();

						SetDlgItemText(IDC_EDT_STR, (CString)agArg[FIRSTARG]);
					}

					CurrentOper = MULTIPLEYING;
				}
			}
			else
			{
				if(CurrentFuncPercent == CALCULATEPERCENT || CurrentFunc != (MyFunction)0)
				{
					agArg[FIRSTARG] = agArg[SECONDARG];
				}
				agArg[SECONDARG] = MyDArg();

				CurrentOper = MULTIPLEYING;
				CurrentFuncEqual = (MyFunctionEqual)0;
				CurrentFuncPercent = (MyFunctionPercent)0;
				CurrentFunc = (MyFunction)0;
			}
			break;

		case IDC_BTN_PARTITION:
			if(CurrentFuncEqual == (MyFunctionEqual)0)
			{
				if(CurrentOper == (MyOperation)0)
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[FIRSTARG] = Buffer;
						delete (&Buffer);
					}

					CurrentOper = PARTITION;
				}
				else
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[SECONDARG] = Buffer;
						delete (&Buffer);
					}

					if(agArg[SECONDARG].GetCondition() == NOTEMPTY)
					{
						CalculateEqual(agArg[FIRSTARG], agArg[SECONDARG], CurrentOper);

						agArg[SECONDARG] = MyDArg();

						SetDlgItemText(IDC_EDT_STR, (CString)agArg[FIRSTARG]);
					}

					CurrentOper = PARTITION;
				}
			}
			else
			{
				if(CurrentFuncPercent == CALCULATEPERCENT || CurrentFunc != (MyFunction)0)
				{
					agArg[FIRSTARG] = agArg[SECONDARG];
				}
				agArg[SECONDARG] = MyDArg();

				CurrentOper = PARTITION;
				CurrentFuncEqual = (MyFunctionEqual)0;
				CurrentFuncPercent = (MyFunctionPercent)0;
				CurrentFunc = (MyFunction)0;
			}
			break;

//---------------------------------------------------------------------------------
//--------------------------------------------------------------------------
//---------------------------------------------------------------------------------

		case IDC_BTN_EQUALLY:
			if(CurrentOper != (MyOperation)0)
			{
				if(MyCStrArg::GetcMyCStrArg() == EXIST)
				{
					agArg[SECONDARG] = Buffer;
					delete (&Buffer);
				}
				
				if(agArg[SECONDARG].GetCondition() == EMPTY)
				{
					agArg[SECONDARG] = agArg[FIRSTARG];
				}

				CurrentFuncEqual = CalculateEqual(agArg[FIRSTARG], agArg[SECONDARG], CurrentOper);

				CurrentFuncPercent = (MyFunctionPercent)0;
				CurrentFunc = (MyFunction)0;

				SetDlgItemText(IDC_EDT_STR, (CString)agArg[FIRSTARG]);
			}
			break;

//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------

		case IDC_BTN_PERSENT:
			if(CurrentOper == (MyOperation)0)
			{
				agArg[FIRSTARG] = MyDArg();

				if(MyCStrArg::GetcMyCStrArg() == EXIST)
					delete (&Buffer);

				Buffer = *(new MyCStrArg);
				
				SetDlgItemText(IDC_EDT_STR, (CString)Buffer);
			}
			else
			{
				if(MyCStrArg::GetcMyCStrArg() == EXIST)
				{
					agArg[SECONDARG] = Buffer;
					delete (&Buffer);
				}

				if(agArg[SECONDARG].GetCondition() == EMPTY || (CurrentFuncEqual == CALCULATEEQUAL && CurrentFuncPercent == (MyFunctionPercent)0 && CurrentFunc == (MyFunction)0))
				{
					agArg[SECONDARG] = agArg[FIRSTARG];
				}

				CurrentFuncPercent = CalculatePercent(agArg[FIRSTARG], agArg[SECONDARG]);

				SetDlgItemText(IDC_EDT_STR, (CString)agArg[SECONDARG]);
			}
			break;

//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------

		case IDC_BTN_VUCHUSL_CHASTN:
			if(CurrentFuncEqual == (MyFunctionEqual)0)
			{
				if(CurrentOper == (MyOperation)0)
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[FIRSTARG] = Buffer;
						delete (&Buffer);
					}

					CurrentFunc = CalculateQuotient(agArg[FIRSTARG]);

					SetDlgItemText(IDC_EDT_STR, (CString)agArg[FIRSTARG]);
				}
				else
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[SECONDARG] = Buffer;
						delete (&Buffer);
					}

					if(agArg[SECONDARG].GetCondition() == EMPTY)
					{
						agArg[SECONDARG] = agArg[FIRSTARG];
					}

					CurrentFunc = CalculateQuotient(agArg[SECONDARG]);

					SetDlgItemText(IDC_EDT_STR, (CString)agArg[SECONDARG]);
				}
			}
			else
			{
				if(MyCStrArg::GetcMyCStrArg() == EXIST)
				{
					agArg[SECONDARG] = Buffer;
					delete (&Buffer);
				}
				else if(CurrentFunc == (MyFunction)0 && CurrentFuncPercent ==(MyFunctionPercent)0)
				{
					agArg[SECONDARG] = agArg[FIRSTARG];
				}

				CurrentFunc = CalculateQuotient(agArg[SECONDARG]);

				SetDlgItemText(IDC_EDT_STR, (CString)agArg[SECONDARG]);
			}
			break;

		case IDC_BTN_SQRT:
			if(CurrentFuncEqual == (MyFunctionEqual)0)
			{
				if(CurrentOper == (MyOperation)0)
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[FIRSTARG] = Buffer;
						delete (&Buffer);
					}

					CurrentFunc = CalculateSqrt(agArg[FIRSTARG]);

					SetDlgItemText(IDC_EDT_STR, (CString)agArg[FIRSTARG]);
				}
				else
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[SECONDARG] = Buffer;
						delete (&Buffer);
					}

					if(agArg[SECONDARG].GetCondition() == EMPTY)
					{
						agArg[SECONDARG] = agArg[FIRSTARG];
					}

					CurrentFunc = CalculateSqrt(agArg[SECONDARG]);

					SetDlgItemText(IDC_EDT_STR, (CString)agArg[SECONDARG]);
				}
			}
			else
			{
				if(MyCStrArg::GetcMyCStrArg() == EXIST)
				{
					agArg[SECONDARG] = Buffer;
					delete (&Buffer);
				}
				else if(CurrentFunc == (MyFunction)0 && CurrentFuncPercent ==(MyFunctionPercent)0)
				{
					agArg[SECONDARG] = agArg[FIRSTARG];
				}

				CurrentFunc = CalculateSqrt(agArg[SECONDARG]);

				SetDlgItemText(IDC_EDT_STR, (CString)agArg[SECONDARG]);
			}
			break;

//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------------

		case IDC_BTN_MC:
			agArg[MEMORYARG] = MyDArg();

			SetDlgItemText(IDC_STC_MEM, _T(""));
			break;

		case IDC_BTN_MR:
			if(CurrentFuncEqual == (MyFunctionEqual)0)
			{
				if(CurrentOper == (MyOperation)0)
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[FIRSTARG] = agArg[MEMORYARG];
						delete (&Buffer);
					}
					else
					{	
						agArg[FIRSTARG] = agArg[MEMORYARG];
					}
				}
				else
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[SECONDARG] = agArg[MEMORYARG];
						delete (&Buffer);
					}
					else
					{	
						agArg[SECONDARG] = agArg[MEMORYARG];
					}
				}
			}
			else
			{
				if(CurrentFunc == (MyFunction)0 && CurrentFuncPercent == (MyFunctionPercent)0)
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[FIRSTARG] = agArg[MEMORYARG];
						delete (&Buffer);
					}
					else
					{	
						agArg[FIRSTARG] = agArg[MEMORYARG];
					}
				}
				else
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[SECONDARG] = agArg[MEMORYARG];
						delete (&Buffer);
					}
					else
					{	
						agArg[SECONDARG] = agArg[MEMORYARG];
					}
				}
			}

			SetDlgItemText(IDC_EDT_STR,	(CString)agArg[MEMORYARG]);
			break;

		case IDC_BTN_MS:
			if(CurrentFuncEqual == (MyFunctionEqual)0)
			{
				if(CurrentOper == (MyOperation)0)
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[MEMORYARG] = agArg[FIRSTARG] = Buffer;
						delete (&Buffer);
					}
					else
					{	
						agArg[MEMORYARG] = agArg[FIRSTARG];
					}
				}
				else
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[MEMORYARG] = agArg[SECONDARG] = Buffer;
						delete (&Buffer);
					}
					else
					{	
						agArg[MEMORYARG] = agArg[SECONDARG];
					}
				}
			}
			else
			{
				if(CurrentFunc == (MyFunction)0 && CurrentFuncPercent == (MyFunctionPercent)0)
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[MEMORYARG] = agArg[FIRSTARG] = Buffer;
						delete (&Buffer);
					}
					else
					{	
						agArg[MEMORYARG] = agArg[FIRSTARG];
					}
				}
				else
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[MEMORYARG] = agArg[SECONDARG] = Buffer;
						delete (&Buffer);
					}
					else
					{	
						agArg[MEMORYARG] = agArg[SECONDARG];
					}
				}
			}

			if(agArg[MEMORYARG] == 0.0)
				SetDlgItemText(IDC_STC_MEM, _T(""));
			else
				SetDlgItemText(IDC_STC_MEM, _T("M"));
			break;

		case IDC_BTN_M_PLUS:
			if(CurrentFuncEqual == (MyFunctionEqual)0)
			{
				if(CurrentOper == (MyOperation)0)
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[MEMORYARG] = agArg[MEMORYARG] + (double)(agArg[FIRSTARG] = Buffer);
						delete (&Buffer);
					}
					else
					{	
						agArg[MEMORYARG] = agArg[MEMORYARG] + (double)agArg[FIRSTARG];
					}
				}
				else
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[MEMORYARG] = agArg[MEMORYARG] + (double)(agArg[SECONDARG] = Buffer);
						delete (&Buffer);
					}
					else
					{	
						agArg[MEMORYARG] = agArg[MEMORYARG] + (double)agArg[SECONDARG];
					}
				}
			}
			else
			{
				if(CurrentFunc == (MyFunction)0 && CurrentFuncPercent == (MyFunctionPercent)0)
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[MEMORYARG] = agArg[MEMORYARG] + (double)(agArg[FIRSTARG] = Buffer);
						delete (&Buffer);
					}
					else
					{	
						agArg[MEMORYARG] = agArg[MEMORYARG] + (double)agArg[FIRSTARG];
					}
				}
				else
				{
					if(MyCStrArg::GetcMyCStrArg() == EXIST)
					{
						agArg[MEMORYARG] = agArg[MEMORYARG] + (double)(agArg[SECONDARG] = Buffer);
						delete (&Buffer);
					}
					else
					{	
						agArg[MEMORYARG] = agArg[MEMORYARG] + (double)agArg[SECONDARG];
					}
				}
			}

			if(agArg[MEMORYARG] == 0.0)
				SetDlgItemText(IDC_STC_MEM, _T(""));
			else
				SetDlgItemText(IDC_STC_MEM, _T("M"));
			break;

//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
		}
	}
	catch(MyError Error)
	{
		switch(Error.GeterCode())
		{
		case INVALIDINPUTINTOARGUMENT:
			Beep(100, 100);
			break;		

		case BACKSPACENOTEXISTINGARGUMENT:
			Beep(100, 100);
			break;

		case INVALIDVALUEOFARGUMENTZERO:
			bDisabledBtns = true;
			SetDlgItemText(IDC_EDT_STR, _T("   "));
			break;

		case INVALIDVALUEOFARGUMENTSUBZERO:
			bDisabledBtns = true;
			SetDlgItemText(IDC_EDT_STR, _T("  "));
			break;

		case UNDEFINEDVALUEOFRESULT:
			bDisabledBtns = true;
			SetDlgItemText(IDC_EDT_STR, _T("  "));
			break;

		case DISABLEDBUTTONS:
			Beep(100, 100);
			break;

		default:
			Beep(100, 100);
			AfxMessageBox(_T("  MyError"));
			break;
		}
	}
	catch(...)
	{
		Beep(100, 100);
		AfxMessageBox(_T(""));
	}
//---------------------------------------------------------------------------------
}