#include "StdAfx.h"
#include <math.h>
#include "MyWCalcLib.h"

//----------------------------------------------------------------------------------------
//-------------------------   ----------------------------
//---------------------------   MyCStrArg------------------------------

enum
{
	PNOTSET = -1,
	PSET = 0
};

//   ()  
CString& DelZero(CString& str)
{
	int PosPoint = str.GetLength() - 1;
	if(str.Find(',') != -1)
		PosPoint = str.Find(',');
	else if(str.Find('.') != -1)
		PosPoint = str.Find('.');

	for(int i = str.GetLength() - 1; i > PosPoint; --i)
	{
		if(str[i] == '0')
			str.Delete(i);
		else
			break;
	}

	return str;
}

//     
CString& SetSimbolOfPoint(CString& str, const char ch)
{
	int i;

	if((i = str.Find(',')) != -1)
	{
		str.Delete(i);
		str.Insert(i, ch);
	}
	else if((i = str.Find('.')) != -1)
	{
		str.Delete(i);		
		str.Insert(i, ch);
	}

	return str;
}

//----------------------------------------------------------------------------------------
//-------------------------  MyCStrArg------------------------------------
//----------------------------------------------------------------------------------------

int MyWCalcLib::MyCStrArg::cMyCStrArg = 0;

MyWCalcLib::MyCStrArg::MyCStrArg() : cstrNumber(""), Sign(SPLUS), cPoint(PNOTSET)
{
	cMyCStrArg++;
}

MyWCalcLib::MyCStrArg::MyCStrArg(const MyWCalcLib::MyCStrArg& rArg)
{
	cMyCStrArg++;
	cstrNumber = rArg.cstrNumber;
	Sign = rArg.Sign;
	cPoint = rArg.cPoint;
}

MyWCalcLib::MyCStrArg& MyWCalcLib::MyCStrArg::operator=(const MyWCalcLib::MyCStrArg& rArg)
{
	if(this == &rArg)
		return *this;
	else
	{
		cstrNumber = rArg.cstrNumber;
		Sign = rArg.Sign;
		cPoint = rArg.cPoint;
	}
	return *this;
}

MyWCalcLib::MyCStrArg::~MyCStrArg()
{
	cMyCStrArg--;
}

MyWCalcLib::MyCStrArg& MyWCalcLib::MyCStrArg::operator+=(const char ch)
{
	if(ch == ',' && cPoint == PNOTSET)
		cPoint++;
	else if(ch != ',')
	{
		if(cPoint == PNOTSET && cstrNumber.GetLength() == 0 && ch == '0')
			;
		else
		{
			cstrNumber += ch;
			if(cPoint > PNOTSET)
				cPoint++;
		}
	}
	else
		throw MyError(INVALIDINPUTINTOARGUMENT);
	return *this;	
}

MyWCalcLib::MyCStrArg& MyWCalcLib::MyCStrArg::Backspace()
{
	if(cPoint == PNOTSET && cstrNumber.GetLength() > 0)
	{
		cstrNumber.Delete(cstrNumber.GetLength() - 1);
		if(cstrNumber.GetLength() == 0)
			Sign = SPLUS;
	}
	else if(cPoint == PSET)
	{
		if(cstrNumber.GetLength() == 0)
		{
			cPoint--;
			Sign = SPLUS;
		}
		else
			cPoint--;
	}
	else if(cPoint > PSET)
	{
		cstrNumber.Delete(cstrNumber.GetLength() - 1);
		cPoint--;
	}
	return *this;
}

MyWCalcLib::MyCStrArg& MyWCalcLib::MyCStrArg::ChangeSign()
{
	if(cstrNumber.GetLength() > 0 || cPoint == PSET)
	{
		Sign = (Sign == SPLUS) ? SMINUS : SPLUS;
	}
	return *this;
}

MyWCalcLib::MyCStrArg::operator CString() const
{
	CString str;

	if(cstrNumber.IsEmpty())
		str = "0";
	else if(cstrNumber.GetLength() == cPoint)
	{
		str = "0";
		str += cstrNumber;
	}
	else
		str = cstrNumber;

	if(cPoint == PNOTSET || cPoint == PSET)
		str += ',';
	else
		str.Insert(str.GetLength() - cPoint, ',');

	if(Sign == SMINUS)
		str.Insert(0, '-');

	return str;
}

MyWCalcLib::MyCStrArg::operator double() const
{
	MyCStrArg cstrArgTmp = (*this);
	return atof(DelZero(SetSimbolOfPoint((CString)cstrArgTmp, '.')));
}

MyWCalcLib::MyCStrArg::MyCStrArg(const double dArg)
{
	cMyCStrArg++;
	cstrNumber.Format(_T("%f"), dArg);
	DelZero(SetSimbolOfPoint(cstrNumber, ','));

	if(cstrNumber.Find('-') == 0)
	{
		Sign = SMINUS;
		cstrNumber.Delete(0);
	}
	else
		Sign = SPLUS;

	cPoint = cstrNumber.GetLength() - 1 - cstrNumber.Find(',');
	if(cPoint == 0)
		cPoint = PNOTSET;
	cstrNumber.Delete(cstrNumber.Find(','));

	if(cstrNumber[0] == '0')
		cstrNumber.Delete(0);

	if(cstrNumber.GetLength() == 0)
		Sign = SPLUS;
}

int MyWCalcLib::MyCStrArg::GetcMyCStrArg()
{
	return cMyCStrArg;
}

//----------------------------------------------------------------------------------------
//-------------------------  MyDArg---------------------------------------
//----------------------------------------------------------------------------------------

MyWCalcLib::MyDArg::MyDArg() : Argument(0), Condition(EMPTY)
{
}

MyWCalcLib::MyDArg::~MyDArg()
{
}

MyWCalcLib::MyDArg& MyWCalcLib::MyDArg::operator=(const MyWCalcLib::MyDArg& rArg)
{
	if(this == &rArg)
		return *this;
	Argument = rArg.Argument;
	Condition = rArg.Condition;
	return *this;
}

MyWCalcLib::MyDArg::MyDArg(const MyWCalcLib::MyDArg& rArg)
{
	Argument = rArg.Argument;
	Condition = rArg.Condition;
}

MyWCalcLib::MyDArg::operator double() const
{
	return Argument;
}
MyWCalcLib::MyDArg::MyDArg(const double d)
{
	Argument = d;
	Condition = NOTEMPTY;
}

MyWCalcLib::MyDArg::operator CString() const
{
	return (CString)(MyCStrArg)(double)(*this);
}

MyWCalcLib::MyDArg::MyDArg(const MyWCalcLib::MyCStrArg& cstrArg)
{
	(*this) = (double)cstrArg;
}

MyWCalcLib::MyCondition MyWCalcLib::MyDArg::GetCondition() const
{
	return Condition;
}

MyWCalcLib::MyDArg& MyWCalcLib::MyDArg::SetCondition(const MyWCalcLib::MyCondition& Condition)
{
	this->Condition  = Condition;
	return *this;
}

//----------------------------------------------------------------------------------------
//-------------------------   ------------------------------
//----------------------------------------------------------------------------------------

MyWCalcLib::MyFunctionEqual MyWCalcLib::CalculateEqual(
	MyWCalcLib::MyDArg& lArg,
	const MyWCalcLib::MyDArg& rArg,
	const MyWCalcLib::MyOperation& Operation)
{
	switch(Operation)
	{
	case PLUS:
		lArg = (double)lArg + (double)rArg;
		break;

	case MINUS:
		lArg = (double)lArg -(double)rArg;
		break;

	case MULTIPLEYING:
		lArg = (double)lArg * (double)rArg;
		break;

	case PARTITION:
		if(rArg == 0.0)
		{
			if(lArg == 0.0)
				throw MyError(UNDEFINEDVALUEOFRESULT);
			else
				throw MyError(INVALIDVALUEOFARGUMENTZERO);
		}
		lArg = (double)lArg / (double)rArg;
		break;
	}

	return CALCULATEEQUAL;
}

MyWCalcLib::MyFunctionPercent MyWCalcLib::CalculatePercent(
	const MyWCalcLib::MyDArg& dFirstArgument,
	MyWCalcLib::MyDArg& dSecondArgument)
{
	dSecondArgument = dFirstArgument / 100.0 * dSecondArgument;

	return CALCULATEPERCENT;
}

MyWCalcLib::MyFunction MyWCalcLib::CalculateQuotient(
	MyWCalcLib::MyDArg& dFirstArgument)
{
	if(dFirstArgument == 0.0)
		throw MyError(INVALIDVALUEOFARGUMENTZERO);
	dFirstArgument = 1.0 / dFirstArgument;				
	return CALCULATEQUOTIENT;
}

MyWCalcLib::MyFunction MyWCalcLib::CalculateSqrt(
	MyWCalcLib::MyDArg& dFirstArgument)
{
	if(dFirstArgument < 0.0)
		throw MyError(INVALIDVALUEOFARGUMENTSUBZERO);
	dFirstArgument = sqrt(dFirstArgument);				
	return CALCULATESQRT;
}

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------