#pragma once
#ifndef __MYWCALCLIB_H__
#define __MYWCALCLIB_H__

namespace MyWCalcLib
{
//----------------------------------------------------------------------------------------
//------------------     --------------------------
//----------------------------------------------------------------------------------------

	enum MyErrorCode
	{
		/*  MyCStrArg, */
		//   ( )
		INVALIDINPUTINTOARGUMENT = 1,
		/*  */
		//   
		INVALIDVALUEOFARGUMENTZERO,
		//  (   )
		UNDEFINEDVALUEOFRESULT,
		//    
		INVALIDVALUEOFARGUMENTSUBZERO,
		/* ,   */
		// Backspace'  
		BACKSPACENOTEXISTINGARGUMENT,
		/* ,  */
		//   
		DISABLEDBUTTONS
	};

	class MyError
	{
	public:
		MyError(MyErrorCode Code) {erCode = Code;}
		MyErrorCode GeterCode() const {return erCode;}
	private:
		MyErrorCode erCode;
	};

//----------------------------------------------------------------------------------------
//--------------------------  MyCStrArg------------------------------------
//----------------------------------------------------------------------------------------

	enum MySign
	{
		SMINUS = -1,
		SPLUS = 1
	};

	enum
	{
		NOTEXIST,
		EXIST
	};

	//     (double)
	// ,    ,  :
	//    ,    / 
	//double       
	// 
	class MyCStrArg
	{
	public:
		MyCStrArg();
		MyCStrArg(const MyCStrArg&);
		MyCStrArg& operator=(const MyCStrArg&);
		~MyCStrArg();

		//   ,  ( ',')   
		//(      )
		MyCStrArg& operator+=(const char);
		MyCStrArg& Backspace();
		MyCStrArg& ChangeSign();

		operator CString() const;
		operator double() const;
		MyCStrArg(const double);

		static int GetcMyCStrArg();
	private:
		CString cstrNumber;
		MySign Sign;
		int cPoint;
		static int cMyCStrArg;
	};

//----------------------------------------------------------------------------------------
//-------------------------------  MyDArg----------------------------------
//----------------------------------------------------------------------------------------

	enum MyCondition
	{
		EMPTY,
		NOTEMPTY
	};

	class MyDArg
	{
	public:
		MyDArg();
		~MyDArg();
		MyDArg& operator=(const MyDArg&);
		MyDArg(const MyDArg&);

		operator double() const;
		MyDArg(const double);
		operator CString() const;
		MyDArg(const MyCStrArg&);
		
		MyCondition GetCondition() const;
		MyDArg& SetCondition(const MyCondition&);
	private:
		double Argument;
		MyCondition Condition;
	};

//----------------------------------------------------------------------------------------
//------------, ,     ----------------
//----------------------------------------------------------------------------------------

	enum
	{
		FIRSTARG,
		SECONDARG,
		MEMORYARG
	};

	enum MyOperation
	{
		PLUS = 1,
		MINUS,
		MULTIPLEYING,
		PARTITION
	};

	enum MyFunctionEqual
	{
		CALCULATEEQUAL = 1,
	};

	MyFunctionEqual CalculateEqual(MyDArg&, const MyDArg&, const MyOperation&);


	enum MyFunctionPercent
	{
		CALCULATEPERCENT = 1,
	};

	MyFunctionPercent CalculatePercent(const MyDArg&, MyDArg&);

	enum MyFunction
	{
		CALCULATEQUOTIENT = 1,
		CALCULATESQRT
	};

	MyFunction CalculateQuotient(MyDArg&);
	MyFunction CalculateSqrt(MyDArg&);

//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------
}

#endif